import javax.swing.*;
import javax.imageio.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.image.*;
import java.net.*;
import java.util.*;

public class BookCatalog implements ActionListener, KeyListener, ItemListener
{
  public static final String ACCESS_KEY = "39GSCAE5";
  public static final char IMAGE_SIZE = 'M';
  public static String url = "192.168.1.115";
  public static String dbname = "bookdb";
  public static String username = "root";
  public static String password = "kpcofgs";
  public static final String SQL_INFO_FILE_PATH = "SQLINFO.txt";
  
  public static boolean manualEntry = false;
  public static int ISBN_TYPE = 13;
  DBConnection dbc;
  public boolean automatic = false;
  JFrame frame, imgFrame;
  public JTextField isbn;
  JLabel info;
  JButton add, clear;
  private String source = "";
  int windowX, windowY;
  JCheckBox auto;
  String isbn10, isbn13, title, author, publisher, edition, physical, price;
  
  public BookCatalog()
  {
    getSQLInfo();
    dbc = new DBConnection(url, username, password);
    dbc.detailedErrorOn(true);
    dbc.connect(dbname);
    System.out.println("BOOK CATALOG OK. Scan setting code or ISBN.");
    frame = new JFrame("Book Catalog");
    JPanel panel = new JPanel(new BorderLayout());
    JPanel infopanel = new JPanel();
    JPanel bottomPanel = new JPanel(new BorderLayout());
    auto = new JCheckBox("Automatic Entry");
    auto.addItemListener(this);
    add = new JButton("Add Book");
    clear = new JButton("Clear");
    add.addActionListener(this);
    clear.addActionListener(this);
    isbn = new JTextField();
    isbn.addKeyListener(this);
    info = new JLabel("");
    infopanel.add(info);
    panel.add(isbn, BorderLayout.NORTH);
    panel.add(infopanel, BorderLayout.CENTER);
    bottomPanel.add(auto, BorderLayout.LINE_START);
    bottomPanel.add(clear, BorderLayout.CENTER);
    bottomPanel.add(add, BorderLayout.LINE_END);
    panel.add(bottomPanel, BorderLayout.SOUTH);
    frame.setResizable(false);
    frame.add(panel);
    frame.pack();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension windowSize = frame.getSize();

    windowX = Math.max(0, (screenSize.width  - windowSize.width ) / 2);
    windowY = Math.max(0, (screenSize.height - windowSize.height) / 2);

    frame.setLocation(windowX, windowY);
    frame.setVisible(true);
  }
  
  public static void main(String args[])
  {
    BookCatalog bc = new BookCatalog();
  }
  
  public void actionPerformed(ActionEvent evt)
  {
    Object obj = evt.getSource();
    if(obj == add)
    {
      updateDatabase();
      isbn.requestFocus();
    }
    
    if(obj == clear)
    {
      clear();
    }
  }
  
  public void getSQLInfo()
  {
    try
    {
      String[] info = null;
      Scanner in = new Scanner(new File(SQL_INFO_FILE_PATH));
      while(in.hasNextLine())
      {
        info = in.nextLine().split(",");
      }
      url = info[0];
      dbname = info[1];
      username = info[2];
      password = info[3];
      System.out.println("SQL Server Details Read From File...");
    }
    catch(Exception e)
    {
      System.exit(0);
    }
  }
  
  public void itemStateChanged(ItemEvent ie)
  {
    Object obj = ie.getItemSelectable();
    if(obj == auto)
    {
      if(auto.isSelected())
      {
        automatic = true;
        add.setEnabled(false);
      }
      else
      {
        automatic = false;
        add.setEnabled(true);
      }
    }
    isbn.requestFocus();
  }
  
  public void keyPressed(KeyEvent ke){}

  public void keyReleased(KeyEvent ke)
  {
    
    if((ke.getKeyCode() == KeyEvent.VK_ENTER) && !(isbn.getText().equals("")))
      {
        if(imgFrame != null)
          {
            imgFrame.setVisible(false);
            imgFrame = null;
          }
          getInfo(isbn.getText());
      }
    
  }

  public void keyTyped(KeyEvent ke)
  {
   if(isbn.getText().length() == 12)
   {
     if(isbn.getText().equals("000000000031"))                       
     {
       ISBN_TYPE = 10;
       System.out.println("SETTINGS --> ISBN TYPE CHANGED TO 10.");
       clear();
     }
     else if(isbn.getText().equals("000000000048"))                                 
     {
       ISBN_TYPE = 13;
       System.out.println("SETTINGS --> ISBN TYPE CHANGED TO 13.");
       clear();
     }
     else if(isbn.getText().equals("000000000017"))
     {
       manualEntry = true;
       System.out.println("SETTINGS --> MANUAL ENTRY IS ON.");
       clear();
     }
     else if(isbn.getText().equals("000000000024"))
     {
       manualEntry = false;
       System.out.println("SETTINGS --> MANUAL ENTRY IS OFF.");
       clear();
     }
   }
    
    
    if(!manualEntry)
    {
      if(isbn.getText().length() == ISBN_TYPE)
      {
      Object obj = ke.getSource();      
      if(obj == isbn)
      {
        System.out.println("Scan Successful! Read: " + isbn.getText());
        if(automatic)
        {
          if(imgFrame != null)
          {
            imgFrame.setVisible(false);
            imgFrame = null;
          }
          getInfo(isbn.getText());
          updateDatabase();
          
        }
        else
        {
          if(imgFrame != null)
          {
            imgFrame.setVisible(false);
            imgFrame = null;
          }
          getInfo(isbn.getText());
        }
      }
      }
    }
    
    
  }
 
  private void clear()
  {
    info.setText("");
      isbn.setText("");
      frame.pack();
      if(imgFrame != null)
      {
        imgFrame.setVisible(false);
        imgFrame = null;
      }
      isbn.requestFocus();
  }
  
  private void getInfo(String isbn)
  {
    try
    {
      
      String url = "http://isbndb.com/api/books.xml?access_key=" + ACCESS_KEY + "&results=details&index1=isbn&value1=" + isbn;
      SimpleNetworkConnection snc = new SimpleNetworkConnection(url);
      source = snc.getSource();
      title = source.substring(source.indexOf("<Title>")+7, source.indexOf("</Title>"));
      author = source.substring(source.indexOf("<AuthorsText>")+13, source.indexOf("</AuthorsText>")).replace(",","");
      
      publisher = source.substring(source.indexOf("<PublisherText publisher_id=\"")+29, source.indexOf("</PublisherText>"));
      publisher = publisher.substring(publisher.indexOf(">")+1);
      
      String details = source.substring(source.indexOf("<Details ")+9, source.indexOf("/>"));
      edition = details.substring(details.indexOf("edition_info=\"")+14, details.indexOf("language")-2);
      physical = details.substring(details.indexOf("physical_description_text=\"")+27, details.indexOf("lcc_number")-2);
      
      String isbnInfo = source.substring(source.indexOf("<BookData")+9, source.indexOf("<Title>"));
      isbn10 = isbnInfo.substring(isbnInfo.indexOf("isbn=")+6, isbnInfo.indexOf("isbn13")-2);
      isbn13 = isbnInfo.substring(isbnInfo.indexOf("isbn13=")+8, isbnInfo.indexOf(">")-1);
      
      /*
      snc = null;
      snc = new SimpleNetworkConnection("http://www.lookupbyisbn.com/Search/Book/" + isbn + "/1");
      source = snc.getSource();
      source = source.substring(source.indexOf("<span class=\"newprice\">")+23);
      price = source.substring(0, source.indexOf("</span>"));
      System.out.println(price);
      */
        
      fetchImage(isbn);
      
      
      info.setText("<html>ISBN-10: " + isbn10 + "<br>" + "ISBN-13: " + isbn13 + "<br>" + "Title: " + title + "<br>" + "Author(s): " + author + "<br>" + "Publisher: " + publisher + "<br>" + "Edition: " + edition + "<br>" + "Physical Description: " + physical + "<br>" + "</html>");
      frame.pack();
    }
    catch(Exception e)
    {
      if(!manualEntry)
      {
        info.setText("Sorry, the ISBN you entered is invalid.");
        frame.pack();
      if(imgFrame != null)
      {
        imgFrame.setVisible(false);
        imgFrame = null;
      }
      focus();
      }
    }
  }
  
  private void focus()
  {
    isbn.setText("");
    isbn.requestFocus();
  }
  
  private void fetchImage(String isbn)
  {
    String imgPath = "http://covers.openlibrary.org/b/isbn/" + isbn10 + "-" + IMAGE_SIZE + ".jpg";
    Image img = null;
    
    try
    {
      URL imgUrl = new URL(imgPath);
      img = ImageIO.read(imgUrl);
      imgFrame = new JFrame();
      imgFrame.setResizable(false);
      JLabel lblImage = new JLabel(new ImageIcon(img));
      imgFrame.getContentPane().add(lblImage, BorderLayout.CENTER);
      imgFrame.pack();
      imgFrame.setLocation((int)(windowX-(frame.getSize().width / 1.5)), (windowY-frame.getSize().height));
      imgFrame.setVisible(true);
      frame.toFront();
      this.isbn.requestFocus();
    }
    catch(Exception e)
    {
    }
    
  }
  
  private boolean recordExists()
  {
    String query = "SELECT bid FROM main WHERE isbn10='" + isbn10 + "' AND isbn13='" + isbn13 + "'";
    ArrayList<String> temp = dbc.query(query);
    if(temp.size() > 0)
    {
      return true;
    }
    return false;
  }
  
  private void updateDatabase()
  {
    if(isbn10 != null && isbn13 != null && title != null && author != null && publisher != null && edition != null && physical != null)
    {
      if(!recordExists())
      {
        physical = physical.replace("\"","\\\"");
        String query = "INSERT INTO main (bid, isbn10, isbn13, Title, Author, Publisher, Edition, Physical, Price) VALUES (0, '" + isbn10 + "', '" + isbn13 + "', '" + title + "', '" + author + "', '" + publisher + "', '" + edition + "', '" + physical + "', " + price + ")";
        //System.out.println(query);
        dbc.query(query);
        if(automatic)
        {
          try
          {
            Tone.sound(700,150,1.0);
          }
          catch(Exception e){}
        }
      }
      else
      {
        if(!automatic)
        {
          if(!manualEntry)
      {
        info.setText("Sorry, the ISBN you entered is invalid.");
        frame.pack();
      if(imgFrame != null)
      {
        imgFrame.setVisible(false);
        imgFrame = null;
      }
      focus();
      }
        }
      }
    }
  }
}